{ -----------------------------------------------------
  Main.pas

  Copyright (c) 1998, 2001  ADC-Soft
  http://www.adcsoft.com

  Example of TSevenSegment

  (See readme.txt for detailed information)
  ----------------------------------------------------- }
unit Main;

interface

uses
  WinProcs, WinTypes, Messages, SysUtils, Classes, Graphics,
  Controls, Forms, Dialogs, Seven, ExtCtrls, StdCtrls, ShellApi;

type
  TForm1 = class(TForm)
    Timer1: TTimer;
    Panel1: TPanel;
    Panel2: TPanel;
    SevenSegment1: TSevenSegment;
    Panel3: TPanel;
    Label1: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    EditValue: TEdit;
    ButtonColor: TButton;
    ButtonOnColor: TButton;
    ButtonOffColor: TButton;
    EditThickness: TEdit;
    EditSpace: TEdit;
    EditHorzSpace: TEdit;
    EditVertSpace: TEdit;
    ComboShowDecimal: TComboBox;
    Label11: TLabel;
    EditNumberOfDigit: TEdit;
    ColorDialog1: TColorDialog;
    Panel4: TPanel;
    Label12: TLabel;
    EditValue1: TEdit;
    ButtonColor1: TButton;
    ButtonOnColor1: TButton;
    ButtonOffColor1: TButton;
    Label21: TLabel;
    ComboShowPlusMinus: TComboBox;
    Label23: TLabel;
    ComboLeadingZeros: TComboBox;
    Label22: TLabel;
    EditColonSpace: TEdit;
    SevenSegmentTime1: TSevenSegmentTime;
    SevenSegment2: TSevenSegment;
    Label2: TLabel;
    ComboShowAMPM: TComboBox;
    Label3: TLabel;
    ComboShowMilliseconds: TComboBox;
    Label4: TLabel;
    EditNumberOfDecimal: TEdit;
    SevenSegment3: TSevenSegment;
    Label5: TLabel;
    ComboShowSeconds: TComboBox;
    Button1: TButton;
    procedure Timer1Timer(Sender: TObject);
    procedure ButtonColorClick(Sender: TObject);
    procedure ButtonOnColorClick(Sender: TObject);
    procedure ButtonOffColorClick(Sender: TObject);
    procedure EditThicknessChange(Sender: TObject);
    procedure EditSpaceChange(Sender: TObject);
    procedure EditHorzSpaceChange(Sender: TObject);
    procedure EditVertSpaceChange(Sender: TObject);
    procedure EditNumberOfDigitChange(Sender: TObject);
    procedure ComboShowDecimalChange(Sender: TObject);
    procedure ComboShowPlusMinusChange(Sender: TObject);
    procedure ComboLeadingZerosChange(Sender: TObject);
    procedure EditColonSpaceChange(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure EditNumberOfDecimalChange(Sender: TObject);
    procedure ComboShowAMPMChange(Sender: TObject);
    procedure ComboShowMillisecondsChange(Sender: TObject);
    procedure ComboShowSecondsChange(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Timer1Timer(Sender: TObject);
var
  Negative: integer;
  Ellapsed: longint;
  jam, menit, detik, ms: Word;
begin
  Negative := random (4);

  if (Negative = 0) then
    Ellapsed := -GetTickCount
  else
    Ellapsed := GetTickCount;
  SevenSegment1.Value := IntToStr (Ellapsed);
  EditValue.Text := SevenSegment1.Value;

  DecodeTime (Time, jam, menit, detik, ms);
  SevenSegmentTime1.Value := IntToStr (jam) + ':' + IntToStr (menit) + ':' +
                             IntToStr (detik) + '-' + IntToStr (ms);
  EditValue1.Text := SevenSegmentTime1.Value;
end;

procedure TForm1.ButtonColorClick(Sender: TObject);
begin
  if ((Sender as TButton).Tag = 0) then
  begin
    ColorDialog1.Color := SevenSegment1.Color;
    if (ColorDialog1.Execute) then
      SevenSegment1.Color := ColorDialog1.Color;
  end
  else
  begin
    ColorDialog1.Color := SevenSegmentTime1.Color;
    if (ColorDialog1.Execute) then
      SevenSegmentTime1.Color := ColorDialog1.Color;
  end;
end;

procedure TForm1.ButtonOnColorClick(Sender: TObject);
begin
  if ((Sender as TButton).Tag = 0) then
  begin
    ColorDialog1.Color := SevenSegment1.OnColor;
    if (ColorDialog1.Execute) then
      SevenSegment1.OnColor := ColorDialog1.Color;
  end
  else
    begin
    ColorDialog1.Color := SevenSegmentTime1.OnColor;
    if (ColorDialog1.Execute) then
      SevenSegmentTime1.OnColor := ColorDialog1.Color;
  end
end;

procedure TForm1.ButtonOffColorClick(Sender: TObject);
begin
  if ((Sender as TButton).Tag = 0) then
  begin
    ColorDialog1.Color := SevenSegment1.OffColor;
    if (ColorDialog1.Execute) then
      SevenSegment1.OffColor := ColorDialog1.Color;
  end
  else
  begin
    ColorDialog1.Color := SevenSegmentTime1.OffColor;
    if (ColorDialog1.Execute) then
      SevenSegmentTime1.OffColor := ColorDialog1.Color;
  end;
end;

procedure TForm1.EditThicknessChange(Sender: TObject);
begin
  if ((Sender as TEdit).Tag = 0) then
  begin
    try
      SevenSegment1.Thickness := StrToInt (EditThickness.Text);
    except
      on EConvertError do
        SevenSegment1.Thickness := 0;
    end
  end
  else
    begin
    try
      SevenSegmentTime1.Thickness := StrToInt (EditThickness.Text);
    except
      on EConvertError do
        SevenSegmentTime1.Thickness := 0;
    end
  end
end;

procedure TForm1.EditSpaceChange(Sender: TObject);
begin
  if ((Sender as TEdit).Tag = 0) then
  begin
    try
      SevenSegment1.Space := StrToInt (EditSpace.Text);
    except
      on EConvertError do
        SevenSegment1.Space := 0;
    end
  end
  else
    begin
    try
      SevenSegmentTime1.Space := StrToInt (EditSpace.Text);
    except
      on EConvertError do
        SevenSegmentTime1.Space := 0;
    end
  end
end;

procedure TForm1.EditHorzSpaceChange(Sender: TObject);
begin
  if ((Sender as TEdit).Tag = 0) then
  begin
    try
      SevenSegment1.HorzSpace := StrToInt (EditHorzSpace.Text);
    except
      on EConvertError do
        SevenSegment1.HorzSpace := 0;
    end
  end
  else
    begin
    try
      SevenSegmentTime1.HorzSpace := StrToInt (EditHorzSpace.Text);
    except
      on EConvertError do
        SevenSegmentTime1.HorzSpace := 0;
    end
  end
end;

procedure TForm1.EditVertSpaceChange(Sender: TObject);
begin
  if ((Sender as TEdit).Tag = 0) then
  begin
    try
      SevenSegment1.VertSpace := StrToInt (EditVertSpace.Text);
    except
      on EConvertError do
        SevenSegment1.VertSpace := 0;
    end
  end
  else
    begin
    try
      SevenSegmentTime1.VertSpace := StrToInt (EditVertSpace.Text);
    except
      on EConvertError do
        SevenSegmentTime1.VertSpace := 0;
    end
  end
end;

procedure TForm1.EditNumberOfDigitChange(Sender: TObject);
begin
  try
    SevenSegment1.NumberOfDigits := StrToInt (EditNumberOfDigit.Text);
  except
    on EConvertError do
      SevenSegment1.NumberOfDigits := 0;
  end
end;

procedure TForm1.ComboShowDecimalChange(Sender: TObject);
begin
  if (ComboShowDecimal.Text = 'true') then
    SevenSegment1.ShowDecimalPoint := true
  else
    SevenSegment1.ShowDecimalPoint := false;
end;

procedure TForm1.ComboShowPlusMinusChange(Sender: TObject);
begin
  if (ComboShowPlusMinus.Text = 'true') then
    SevenSegment1.ShowPlusMinus := true
  else
    SevenSegment1.ShowPlusMinus := false;
end;

procedure TForm1.ComboLeadingZerosChange(Sender: TObject);
begin
  if (ComboLeadingZeros.Text = 'true') then
    SevenSegment1.LeadingZeros := true
  else
    SevenSegment1.LeadingZeros := false;
end;

procedure TForm1.EditColonSpaceChange(Sender: TObject);
begin
  try
    SevenSegmentTime1.ColonSpace := StrToInt (EditColonSpace.Text);
  except
    on EConvertError do
      SevenSegmentTime1.ColonSpace := 0;
  end
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  randomize;

  EditThickness.Text       := IntToStr (SevenSegment1.Thickness);
  EditSpace.Text           := IntToStr (SevenSegment1.Space);
  EditHorzSpace.Text       := IntToStr (SevenSegment1.HorzSpace);
  EditVertSpace.Text       := IntToStr (SevenSegment1.VertSpace);
  EditNumberOfDigit.Text   := IntToStr (SevenSegment1.NumberOfDigits);
  EditNumberOfDecimal.Text := IntToStr (SevenSegment1.NumberOfDecimals);
  if (SevenSegment1.ShowDecimalPoint) then
    ComboShowDecimal.ItemIndex := 0
  else
    ComboShowDecimal.ItemIndex := 0;
  if (SevenSegment1.ShowPlusMinus) then
    ComboShowPlusMinus.ItemIndex := 0
  else
    ComboShowPlusMinus.ItemIndex := 1;
  if (SevenSegment1.LeadingZeros) then
    ComboLeadingZeros.ItemIndex := 0
  else
    ComboLeadingZeros.ItemIndex := 1;

  EditColonSpace.Text := IntToStr (SevenSegmentTime1.ColonSpace);
  if (SevenSegmentTime1.ShowAMPM) then
    ComboShowAMPM.ItemIndex := 0
  else
    ComboShowAMPM.ItemIndex := 1;
  if (SevenSegmentTime1.ShowMilliSeconds) then
    ComboShowMilliSeconds.ItemIndex := 0
  else
    ComboShowMilliSeconds.ItemIndex := 1;
  if (SevenSegmentTime1.ShowSeconds) then
    ComboShowSeconds.ItemIndex := 0
  else
    ComboShowSeconds.ItemIndex := 1;
end;

procedure TForm1.EditNumberOfDecimalChange(Sender: TObject);
begin
  try
    SevenSegment1.NumberOfDecimals := StrToInt (EditNumberOfDecimal.Text);
  except
    on EConvertError do
      SevenSegment1.NumberOfDecimals := 0;
  end
end;

procedure TForm1.ComboShowAMPMChange(Sender: TObject);
begin
  if (ComboShowAMPM.Text = 'true') then
    SevenSegmentTime1.ShowAMPM := true
  else
    SevenSegmentTime1.ShowAMPM := false;
end;

procedure TForm1.ComboShowMillisecondsChange(Sender: TObject);
begin
  if (ComboShowMilliSeconds.Text = 'true') then
    SevenSegmentTime1.ShowMilliSeconds := true
  else
    SevenSegmentTime1.ShowMilliSeconds := false;
end;

procedure TForm1.ComboShowSecondsChange(Sender: TObject);
begin
  if (ComboShowSeconds.Text = 'true') then
    SevenSegmentTime1.ShowSeconds := true
  else
    SevenSegmentTime1.ShowSeconds := false;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  ShellExecute (
    Handle, nil,
    'http://www.adcsoft.com/sevensegment.html',
    nil, nil, SW_SHOWNORMAL);
end;

end.
